--
-- SideMirror
--
-- Seiten Spiegel (Links/Rechts)
--
-- by Bruse
--

SideMirror = {};

local sideMirror_directory = g_currentModDirectory;

function SideMirror.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function SideMirror:load()

	-- SpiegelLinks
		self.showLeftMirror = false;
		self.viewportLeft = 2;
		self.ohlX = 0.0086;
		self.ohlW = 0.15;
		self.ohlY = 0.50;
		self.ohlH = 0.255;
		self.ohlOverlay = Overlay:new("hudOHlOverlay", Utils.getFilename("SideMirroPanel.dds", sideMirror_directory), self.ohlX, self.ohlY, self.ohlW, self.ohlH);

	-- SpiegelRechts
		self.showRightMirror = false;
		self.viewportRight = 1;
		self.ohrX = 0.845;
		self.ohrW = 0.15;
		self.ohrY = 0.50;
		self.ohrH = 0.255;
		self.ohrOverlay = Overlay:new("hudOHrOverlay", Utils.getFilename("SideMirroPanel.dds", sideMirror_directory), self.ohrX, self.ohrY, self.ohrW, self.ohrH);
end;

function SideMirror:mouseEvent(posX, posY, isDown, isUp, button)
end;

function SideMirror:keyEvent(unicode, sym, modifier, isDown)
end;

function SideMirror:update()

       if self:getIsActiveForInput() then
           if InputBinding.hasEvent(InputBinding.SideMirror) then
				--LinkerSpiegel
				self.showLeftMirror = not self.showLeftMirror;
				--RechterSpiegel
				self.showRightMirror = not self.showRightMirror;
	        end;
	    end;
end;
	
function SideMirror:draw()

    if not self.showLeftMirror then
        g_currentMission:addHelpButtonText(string.format(Steerable.Side_on, self.typeDesc), InputBinding.SideMirror);
    else
        g_currentMission:addHelpButtonText(string.format(Steerable.Side_off, self.typeDesc), InputBinding.SideMirror);
    end;

	--Linker Spiegel
		if self.isEntered then
			if not self.showLeftMirror then
				link(self.rootNode, self.viewportLeft);
				setRootNode (getRootNode (), self.viewportLeft);
				setViewport(self.viewportLeft, 0.012, 0.25, 0.146, 0.246);
				setCamera(0,self.viewportLeft);
			else 
				self.CamLeft = createCamera("CamLeft", 70, 0.1, 100);
				link(self.rootNode, self.CamLeft);
				translate (self.CamLeft,1.6,3,-0.2);
				rotate(self.CamLeft,0,0,0);
				setRootNode (getRootNode (), self.viewportLeft);
				setViewport(self.viewportLeft, 0.012, 0.25, 0.146, 0.246);
				setCamera(self.CamLeft,self.viewportLeft);
				self.ohlOverlay:render();
			end;
		end;

	--Rechter Spiegel
		if self.isEntered then
			if not self.showRightMirror then
				link(self.rootNode, self.viewportRight);
				setRootNode (getRootNode (), self.viewportRight);
				setViewport(self.viewportRight, 0.846, 0.25, 0.146, 0.246);
				setCamera(0,self.viewportRight);
			else
				self.CamRight = createCamera("CamRight", 70, 0.1, 100);
				link(self.rootNode, self.CamRight);
				translate (self.CamRight,-1.6,3,0.2);
				rotate(self.CamRight,0,0,0);
				setRootNode (getRootNode (),self.viewportRight);
				setViewport(self.viewportRight, 0.846, 0.25, 0.146, 0.246);
				setCamera(self.CamRight,self.viewportRight);
				self.ohrOverlay:render();
			end;
		end;
end;

function SideMirror:delete()
end;

function SideMirror:onLeave()

	--Linker Spiegel
		link(self.rootNode, self.viewportLeft);
		setRootNode (getRootNode (),self.viewportLeft);
		setViewport(self.viewportLeft, 0.012, 0.25, 0.146, 0.246);
		setCamera(0,self.viewportLeft);
		
	--Rechter Spiegel
		link(self.rootNode, self.viewportRight);
		setRootNode (getRootNode (), self.viewportRight);
		setViewport(self.viewportRight, 0.846, 0.25, 0.146, 0.246);
		setCamera(0,self.viewportRight);
end;
